<template>
	<mind-form v-model="formViaje" title="Despachar Viaje"
		@submit="onSubmitViaje" hide-buttons :rules="rules"
		>
			<template v-slot="{form}">			
				<el-row>
					<el-col  :lg="12" >
						<el-form-item  label="Origen">
							<b>{{form.origenCalle}} {{form.origenNumero}}</b>
						</el-form-item>
					</el-col>
					<el-col  :lg="12" >
						<el-form-item  label="entre">
							<b>{{form.origenCalle1}} y {{form.origenCalle2}}</b>
						</el-form-item>
					</el-col>
					<el-col  :lg="12" >
						<el-form-item  label="Destino">
							<b>{{form.destinoCalle}} {{form.destinoNumero}}</b>
						</el-form-item>
					</el-col>
					<el-col  :lg="24" >
						<el-form-item  label="Planilla">
							<b>{{form.idPlanilla}}</b>
						</el-form-item>
					</el-col>
					<el-col  :lg="24" >
						<el-form-item  label="Notas">
							<b>{{form.obs}}</b>
						</el-form-item>
					</el-col>
					<!-- <el-col  :lg="12" >
						<el-form-item label="Fecha Llegada" >
							<el-input
								disabled
								type="date"
								v-model="form.fechaLlegada">
							</el-input>
						</el-form-item>
					</el-col>
					<el-col  :lg="12" >
						<el-form-item label="Hora Llegada" >
							<el-input
								disabled
								type="time"
								v-model="form.horaLlegada">
							</el-input>
						</el-form-item>
					</el-col> -->
					<el-col  :lg="12" >
						<el-form-item label="Importe Viaje" prop="importe">
							<el-input
								type="text" v-model.number="form.importe">
								<template slot="prepend">$</template>
							</el-input>
						</el-form-item>
					</el-col>
					<el-col  :lg="12" >
						<el-form-item label="Importe Espera" prop="espera">
							<el-input
								type="number"	v-model.number="form.espera">
								<template slot="prepend">$</template>
							</el-input>
						</el-form-item>
					</el-col>


				</el-row>
			</template>
			<template  v-slot:footer="{submit}" >
				<el-button type="primary" @click="submit()">Finalizar Viaje</el-button>
			</template>
	</mind-form>
</template>
<script>
import store from '@/store/viajes'
// import planillas from '@/store/planillas'
import {Rest, Rules} from '@/../modules/mind-core-vue/'
export default {
	props: {
		idViaje: [Number, String],
	},
	computed: {

	},
	methods: {
		/**
		 * Obtiene los datos del viaje seleccionado
		 * @param id id de viaje
		 */
		async fetchViaje(id) {
			this.formViaje = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
		},


		/**
		 * Actualiza viaje
		 * @param viaje datos del viaje
		 */
		async onSubmitViaje(viaje) {
			const now = new Date()
			const fecha = `${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}`
			const hora = `${now.getHours()}:${now.getMinutes()<10 ? '0'+ now.getMinutes(): now.getMinutes()}`
			let result, msg ;
			if(viaje.id) { //viaje Existente
				const data = Object.assign({}, viaje)
				data.estado = 'Finalizado'
				data.fechaLlegada = fecha
				data.horaLlegada = hora
				// const data = {
				// 	...viaje,
				// 	estado: 'Finalizado',
				// 	fechaLlegada: fecha,
				// 	horaLlegada: hora,
				// }
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Viaje finalizado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
				this.$emit('submit',data)
			} 
			this.$message({
				type: result,
				showClose: true,
				message: msg
			});
		},
	},
	watch: {
		idViaje: {
			immediate: true,
			handler(v) {
				console.log(v)
				this.api = new Rest({
					uri: `api/agencias/${store.idAgencia}/viajes`, 
					state: store.data,
					key: 'id'})
				if(v) {
					this.fetchViaje(v)
				} 
			}
		},
	},
	data() {
		return {
			formViaje: {},
			rules:{
				importe: [
					Rules.required,
				],
				// espera: [
				// 	Rules.required,
				// ]
			}
		}
	}

}
</script>
<style scoped>
.el-divider {
	margin: 10px 0px;
}

</style>
